package org.springblade.common.upyzt.model;

import org.springblade.common.upyzt.exception.UpyztException;
import org.springblade.common.upyzt.net.APIResource;
import org.springblade.common.upyzt.net.RequestOptions;
import org.springblade.common.upyzt.resp.PaymentResp;
import lombok.experimental.Accessors;

import java.util.Map;

@Accessors(chain = true)
public class Payment extends APIResource {

    /**
     * 消费（转账）
     *
     * @param params 请求参数
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp create(Map<String, Object> params) throws UpyztException {
        return create(params, null);
    }

    /**
     * 消费（转账）
     *
     * @param params  请求参数
     * @param options 参数选项
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp create(Map<String, Object> params, RequestOptions options) throws UpyztException {
        return APIResource.request(RequestMethod.POST, classURL(Payment.class), params, PaymentResp.class, options);
    }

    /**
     * 消费（转账）订单查询（系统订单号）
     *
     * @param id 系统订单号
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp retrieveById(String id) throws UpyztException {
        return retrieveById(id, null);
    }

    /**
     * 消费（转账）订单查询（系统订单号）
     *
     * @param id      系统订单号
     * @param options 参数选项
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp retrieveById(String id, RequestOptions options) throws UpyztException {
        return APIResource.request(RequestMethod.GET, instanceURL(Payment.class, id), null, PaymentResp.class, options);
    }

    /**
     * 消费（转账）订单查询（平台订单号）
     *
     * @param outOrderNo 平台订单号
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp retrieveByOutOrderNo(String outOrderNo) throws UpyztException {
        return retrieveByOutOrderNo(outOrderNo, null);
    }

    /**
     * 消费（转账）订单查询（平台订单号）
     *
     * @param outOrderNo 平台订单号
     * @param options    参数选项
     * @return 返回参数
     * @throws UpyztException 异常
     */
    public static PaymentResp retrieveByOutOrderNo(String outOrderNo, RequestOptions options) throws UpyztException {
        return APIResource.request(RequestMethod.GET, instanceURL(Payment.class, "_by_out_order_no", outOrderNo), null, PaymentResp.class, options);
    }

}
